/**
 * Data API
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import CompanyDatapointResponse from '../model/CompanyDatapointResponse';
import CompanyDescriptionResponse from '../model/CompanyDescriptionResponse';
import CompanyFinancialsResponse from '../model/CompanyFinancialsResponse';
import CompanyPeriodDatesResponse from '../model/CompanyPeriodDatesResponse';
import CompanyTimeSeriesResponse from '../model/CompanyTimeSeriesResponse';
import ComparablesResponse from '../model/ComparablesResponse';

/**
* Default service.
* @module api/DefaultApi
* @version 1.0.0
*/
export default class DefaultApi {

    /**
    * Constructs a new DefaultApi. 
    * @alias module:api/DefaultApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the apiConsumerProjectLocalGetCompanyComparablesSubtypes operation.
     * @callback module:api/DefaultApi~apiConsumerProjectLocalGetCompanyComparablesSubtypesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ComparablesResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get company comparables
     * Returns comparables data for a list of companies for the allowed coverage_universe
     * @param {String} interval identifier for the interval of comparables data to fetch
     * @param {Object} opts Optional parameters
     * @param {Date} [atTimestamp] ISO-8601 Timestamp to return comparables snapshot for
     * @param {String} [companyIds] filter by supplied company ids
     * @param {Number} [limit] maximum number of results to return - typically used when paging
     * @param {String} [continuationToken] identifier of last result in previous result set - allows continuation of paged results
     * @param {String} [acceptEncoding = 'gzip, deflate, br')] client supported encodings (gzip, deflate, br)
     * @param {module:api/DefaultApi~apiConsumerProjectLocalGetCompanyComparablesSubtypesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ComparablesResponse}
     */
    apiConsumerProjectLocalGetCompanyComparablesSubtypes(interval, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'interval' is set
      if (interval === undefined || interval === null) {
        throw new Error("Missing the required parameter 'interval' when calling apiConsumerProjectLocalGetCompanyComparablesSubtypes");
      }

      let pathParams = {
        'interval': interval
      };
      let queryParams = {
        'at_timestamp': opts['atTimestamp'],
        'company_ids': opts['companyIds'],
        'limit': opts['limit'],
        'continuation_token': opts['continuationToken']
      };
      let headerParams = {
        'Accept-Encoding': opts['acceptEncoding']
      };
      let formParams = {
      };

      let authNames = ['authorizeClient'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = ComparablesResponse;
      return this.apiClient.callApi(
        '/comparables/{interval}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the apiConsumerProjectLocalGetCompanyDatapoint operation.
     * @callback module:api/DefaultApi~apiConsumerProjectLocalGetCompanyDatapointCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CompanyDatapointResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a company datapoint
     * Returns details of an individual datapoint for a company
     * @param {String} datapointId identifier for the datapoint
     * @param {Object} opts Optional parameters
     * @param {String} [acceptEncoding = 'gzip, deflate, br')] client supported encodings (gzip, deflate, br)
     * @param {module:api/DefaultApi~apiConsumerProjectLocalGetCompanyDatapointCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CompanyDatapointResponse}
     */
    apiConsumerProjectLocalGetCompanyDatapoint(datapointId, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'datapointId' is set
      if (datapointId === undefined || datapointId === null) {
        throw new Error("Missing the required parameter 'datapointId' when calling apiConsumerProjectLocalGetCompanyDatapoint");
      }

      let pathParams = {
        'datapointId': datapointId
      };
      let queryParams = {
      };
      let headerParams = {
        'Accept-Encoding': opts['acceptEncoding']
      };
      let formParams = {
      };

      let authNames = ['authorizeClient'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = CompanyDatapointResponse;
      return this.apiClient.callApi(
        '/datapoints/{datapointId}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the apiConsumerProjectLocalGetCompanyFinancials operation.
     * @callback module:api/DefaultApi~apiConsumerProjectLocalGetCompanyFinancialsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CompanyFinancialsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get company financials
     * Returns historical financials data for single company
     * @param {String} companyId identifier for the company to fetch financials for
     * @param {Object} opts Optional parameters
     * @param {Date} [atTimestamp] ISO-8601 Timestamp to return financials snapshot for
     * @param {String} [acceptEncoding = 'gzip, deflate, br')] client supported encodings (gzip, deflate, br)
     * @param {module:api/DefaultApi~apiConsumerProjectLocalGetCompanyFinancialsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CompanyFinancialsResponse}
     */
    apiConsumerProjectLocalGetCompanyFinancials(companyId, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'companyId' is set
      if (companyId === undefined || companyId === null) {
        throw new Error("Missing the required parameter 'companyId' when calling apiConsumerProjectLocalGetCompanyFinancials");
      }

      let pathParams = {
        'companyId': companyId
      };
      let queryParams = {
        'at_timestamp': opts['atTimestamp']
      };
      let headerParams = {
        'Accept-Encoding': opts['acceptEncoding']
      };
      let formParams = {
      };

      let authNames = ['authorizeClient'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = CompanyFinancialsResponse;
      return this.apiClient.callApi(
        '/companies/{companyId}/financials', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the apiConsumerProjectLocalGetCompanyListings operation.
     * @callback module:api/DefaultApi~apiConsumerProjectLocalGetCompanyListingsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CompanyDescriptionResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get company descriptions
     * Returns a list of company description objects.
     * @param {Object} opts Optional parameters
     * @param {Date} [atTimestamp] ISO-8601 Timestamp to return companies snapshot for
     * @param {String} [isRetired] filter by 'retired' status - (true|false)
     * @param {String} [companyIds] filter by supplied company ids - comma separated list
     * @param {String} [tickers] filter by supplied company tickers
     * @param {Number} [limit] maximum number of results to return - typically used when paging
     * @param {Date} [updatedAfter] Only return company descriptions added or updated on or after this ISO-8601 timestamp
     * @param {Date} [updatedBefore] Only return company descriptions added or updated before this ISO-8601 timestamp
     * @param {Date} [lastReportedDateAfter] Only return company descriptions for companies with reports on or after this ISO-8601 timestamp
     * @param {Date} [lastReportedDateBefore] Only return company descriptions for companies with reports before this ISO-8601 timestamp
     * @param {String} [continuationToken] identifier of last result in previous result set - allows continuation of paged results
     * @param {String} [acceptEncoding = 'gzip, deflate, br')] client supported encodings (gzip, deflate, br)
     * @param {module:api/DefaultApi~apiConsumerProjectLocalGetCompanyListingsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CompanyDescriptionResponse}
     */
    apiConsumerProjectLocalGetCompanyListings(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'at_timestamp': opts['atTimestamp'],
        'is_retired': opts['isRetired'],
        'company_ids': opts['companyIds'],
        'tickers': opts['tickers'],
        'limit': opts['limit'],
        'updated_after': opts['updatedAfter'],
        'updated_before': opts['updatedBefore'],
        'last_reported_date_after': opts['lastReportedDateAfter'],
        'last_reported_date_before': opts['lastReportedDateBefore'],
        'continuation_token': opts['continuationToken']
      };
      let headerParams = {
        'Accept-Encoding': opts['acceptEncoding']
      };
      let formParams = {
      };

      let authNames = ['authorizeClient'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = CompanyDescriptionResponse;
      return this.apiClient.callApi(
        '/companies', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the apiConsumerProjectLocalGetCompanyTimeSeries operation.
     * @callback module:api/DefaultApi~apiConsumerProjectLocalGetCompanyTimeSeriesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CompanyTimeSeriesResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get company time series
     * Returns all historical values of a specific comparable for a given company and interval
     * @param {String} companyId identifier for the company to fetch time series data for
     * @param {String} tag identifier for the comparable tag to fetch time series data for
     * @param {String} interval identifier for the interval to fetch time series data for
     * @param {Object} opts Optional parameters
     * @param {String} [acceptEncoding = 'gzip, deflate, br')] client supported encodings (gzip, deflate, br)
     * @param {module:api/DefaultApi~apiConsumerProjectLocalGetCompanyTimeSeriesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CompanyTimeSeriesResponse}
     */
    apiConsumerProjectLocalGetCompanyTimeSeries(companyId, tag, interval, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'companyId' is set
      if (companyId === undefined || companyId === null) {
        throw new Error("Missing the required parameter 'companyId' when calling apiConsumerProjectLocalGetCompanyTimeSeries");
      }
      // verify the required parameter 'tag' is set
      if (tag === undefined || tag === null) {
        throw new Error("Missing the required parameter 'tag' when calling apiConsumerProjectLocalGetCompanyTimeSeries");
      }
      // verify the required parameter 'interval' is set
      if (interval === undefined || interval === null) {
        throw new Error("Missing the required parameter 'interval' when calling apiConsumerProjectLocalGetCompanyTimeSeries");
      }

      let pathParams = {
        'companyId': companyId,
        'tag': tag,
        'interval': interval
      };
      let queryParams = {
      };
      let headerParams = {
        'Accept-Encoding': opts['acceptEncoding']
      };
      let formParams = {
      };

      let authNames = ['authorizeClient'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = CompanyTimeSeriesResponse;
      return this.apiClient.callApi(
        '/companies/{companyId}/timeseries/{tag}/{interval}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the apiConsumerProjectLocalGetComparablesUpdatesSince operation.
     * @callback module:api/DefaultApi~apiConsumerProjectLocalGetComparablesUpdatesSinceCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ComparablesResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get company comparables updates for a given time period
     * Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
     * @param {Object} opts Optional parameters
     * @param {Date} [startTimestamp] ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp)
     * @param {Date} [endTimestamp] ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp)
     * @param {String} [companyIds] filter by supplied company ids
     * @param {Number} [limit] maximum number of results to return - typically used when paging
     * @param {String} [continuationToken] identifier of last result in previous result set - allows continuation of paged results
     * @param {String} [acceptEncoding = 'gzip, deflate, br')] client supported encodings (gzip, deflate, br)
     * @param {module:api/DefaultApi~apiConsumerProjectLocalGetComparablesUpdatesSinceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ComparablesResponse}
     */
    apiConsumerProjectLocalGetComparablesUpdatesSince(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'start_timestamp': opts['startTimestamp'],
        'end_timestamp': opts['endTimestamp'],
        'company_ids': opts['companyIds'],
        'limit': opts['limit'],
        'continuation_token': opts['continuationToken']
      };
      let headerParams = {
        'Accept-Encoding': opts['acceptEncoding']
      };
      let formParams = {
      };

      let authNames = ['authorizeClient'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = ComparablesResponse;
      return this.apiClient.callApi(
        '/comparables/updates', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the apiConsumerProjectLocalGetPeriodDates operation.
     * @callback module:api/DefaultApi~apiConsumerProjectLocalGetPeriodDatesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CompanyPeriodDatesResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get company period dates
     * Returns end dates of financial reporting periods for given company
     * @param {String} companyId identifier for the company to fetch financials for
     * @param {Object} opts Optional parameters
     * @param {String} [acceptEncoding = 'gzip, deflate, br')] client supported encodings (gzip, deflate, br)
     * @param {module:api/DefaultApi~apiConsumerProjectLocalGetPeriodDatesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CompanyPeriodDatesResponse}
     */
    apiConsumerProjectLocalGetPeriodDates(companyId, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'companyId' is set
      if (companyId === undefined || companyId === null) {
        throw new Error("Missing the required parameter 'companyId' when calling apiConsumerProjectLocalGetPeriodDates");
      }

      let pathParams = {
        'companyId': companyId
      };
      let queryParams = {
      };
      let headerParams = {
        'Accept-Encoding': opts['acceptEncoding']
      };
      let formParams = {
      };

      let authNames = ['authorizeClient'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = CompanyPeriodDatesResponse;
      return this.apiClient.callApi(
        '/companies/{companyId}/periods', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
