/**
 * Data API
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import CommentRefsInner from './CommentRefsInner';
import PartsInner from './PartsInner';

/**
 * The CompanyDatapointResponseData model module.
 * @module model/CompanyDatapointResponseData
 * @version 1.0.0
 */
class CompanyDatapointResponseData {
    /**
     * Constructs a new <code>CompanyDatapointResponseData</code>.
     * @alias module:model/CompanyDatapointResponseData
     * @param comment {String} 
     * @param commentRefs {Array.<module:model/CommentRefsInner>} 
     * @param companyId {String} 
     * @param displayLabel {String} 
     * @param generatedAt {Date} 
     * @param id {String} 
     * @param notMeaningful {Boolean} 
     * @param pageNumber {Number} 
     * @param parts {Array.<module:model/PartsInner>} 
     * @param period {String} 
     * @param sourceDoc {String} 
     * @param sourceType {String} 
     * @param tag {String} 
     * @param updatedAt {Date} 
     * @param value {String} 
     */
    constructor(comment, commentRefs, companyId, displayLabel, generatedAt, id, notMeaningful, pageNumber, parts, period, sourceDoc, sourceType, tag, updatedAt, value) { 
        
        CompanyDatapointResponseData.initialize(this, comment, commentRefs, companyId, displayLabel, generatedAt, id, notMeaningful, pageNumber, parts, period, sourceDoc, sourceType, tag, updatedAt, value);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, comment, commentRefs, companyId, displayLabel, generatedAt, id, notMeaningful, pageNumber, parts, period, sourceDoc, sourceType, tag, updatedAt, value) { 
        obj['comment'] = comment;
        obj['comment_refs'] = commentRefs;
        obj['company_id'] = companyId;
        obj['display_label'] = displayLabel;
        obj['generated_at'] = generatedAt;
        obj['id'] = id;
        obj['not_meaningful'] = notMeaningful;
        obj['page_number'] = pageNumber;
        obj['parts'] = parts;
        obj['period'] = period;
        obj['source_doc'] = sourceDoc;
        obj['source_type'] = sourceType;
        obj['tag'] = tag;
        obj['updated_at'] = updatedAt;
        obj['value'] = value;
    }

    /**
     * Constructs a <code>CompanyDatapointResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/CompanyDatapointResponseData} obj Optional instance to populate.
     * @return {module:model/CompanyDatapointResponseData} The populated <code>CompanyDatapointResponseData</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new CompanyDatapointResponseData();

            if (data.hasOwnProperty('comment')) {
                obj['comment'] = ApiClient.convertToType(data['comment'], 'String');
            }
            if (data.hasOwnProperty('comment_refs')) {
                obj['comment_refs'] = ApiClient.convertToType(data['comment_refs'], [CommentRefsInner]);
            }
            if (data.hasOwnProperty('company_id')) {
                obj['company_id'] = ApiClient.convertToType(data['company_id'], 'String');
            }
            if (data.hasOwnProperty('display_label')) {
                obj['display_label'] = ApiClient.convertToType(data['display_label'], 'String');
            }
            if (data.hasOwnProperty('generated_at')) {
                obj['generated_at'] = ApiClient.convertToType(data['generated_at'], 'Date');
            }
            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'String');
            }
            if (data.hasOwnProperty('not_meaningful')) {
                obj['not_meaningful'] = ApiClient.convertToType(data['not_meaningful'], 'Boolean');
            }
            if (data.hasOwnProperty('page_number')) {
                obj['page_number'] = ApiClient.convertToType(data['page_number'], 'Number');
            }
            if (data.hasOwnProperty('parts')) {
                obj['parts'] = ApiClient.convertToType(data['parts'], [PartsInner]);
            }
            if (data.hasOwnProperty('period')) {
                obj['period'] = ApiClient.convertToType(data['period'], 'String');
            }
            if (data.hasOwnProperty('source_doc')) {
                obj['source_doc'] = ApiClient.convertToType(data['source_doc'], 'String');
            }
            if (data.hasOwnProperty('source_type')) {
                obj['source_type'] = ApiClient.convertToType(data['source_type'], 'String');
            }
            if (data.hasOwnProperty('tag')) {
                obj['tag'] = ApiClient.convertToType(data['tag'], 'String');
            }
            if (data.hasOwnProperty('updated_at')) {
                obj['updated_at'] = ApiClient.convertToType(data['updated_at'], 'Date');
            }
            if (data.hasOwnProperty('value')) {
                obj['value'] = ApiClient.convertToType(data['value'], 'String');
            }
        }
        return obj;
    }

    /**
     * Validates the JSON data with respect to <code>CompanyDatapointResponseData</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>CompanyDatapointResponseData</code>.
     */
    static validateJSON(data) {
        // check to make sure all required properties are present in the JSON string
        for (const property of CompanyDatapointResponseData.RequiredProperties) {
            if (!data[property]) {
                throw new Error("The required field `" + property + "` is not found in the JSON data: " + JSON.stringify(data));
            }
        }
        // ensure the json data is a string
        if (data['comment'] && !(typeof data['comment'] === 'string' || data['comment'] instanceof String)) {
            throw new Error("Expected the field `comment` to be a primitive type in the JSON string but got " + data['comment']);
        }
        if (data['comment_refs']) { // data not null
            // ensure the json data is an array
            if (!Array.isArray(data['comment_refs'])) {
                throw new Error("Expected the field `comment_refs` to be an array in the JSON data but got " + data['comment_refs']);
            }
            // validate the optional field `comment_refs` (array)
            for (const item of data['comment_refs']) {
                CommentRefsInner.validateJSON(item);
            };
        }
        // ensure the json data is a string
        if (data['company_id'] && !(typeof data['company_id'] === 'string' || data['company_id'] instanceof String)) {
            throw new Error("Expected the field `company_id` to be a primitive type in the JSON string but got " + data['company_id']);
        }
        // ensure the json data is a string
        if (data['display_label'] && !(typeof data['display_label'] === 'string' || data['display_label'] instanceof String)) {
            throw new Error("Expected the field `display_label` to be a primitive type in the JSON string but got " + data['display_label']);
        }
        // ensure the json data is a string
        if (data['id'] && !(typeof data['id'] === 'string' || data['id'] instanceof String)) {
            throw new Error("Expected the field `id` to be a primitive type in the JSON string but got " + data['id']);
        }
        if (data['parts']) { // data not null
            // ensure the json data is an array
            if (!Array.isArray(data['parts'])) {
                throw new Error("Expected the field `parts` to be an array in the JSON data but got " + data['parts']);
            }
            // validate the optional field `parts` (array)
            for (const item of data['parts']) {
                PartsInner.validateJSON(item);
            };
        }
        // ensure the json data is a string
        if (data['period'] && !(typeof data['period'] === 'string' || data['period'] instanceof String)) {
            throw new Error("Expected the field `period` to be a primitive type in the JSON string but got " + data['period']);
        }
        // ensure the json data is a string
        if (data['source_doc'] && !(typeof data['source_doc'] === 'string' || data['source_doc'] instanceof String)) {
            throw new Error("Expected the field `source_doc` to be a primitive type in the JSON string but got " + data['source_doc']);
        }
        // ensure the json data is a string
        if (data['source_type'] && !(typeof data['source_type'] === 'string' || data['source_type'] instanceof String)) {
            throw new Error("Expected the field `source_type` to be a primitive type in the JSON string but got " + data['source_type']);
        }
        // ensure the json data is a string
        if (data['tag'] && !(typeof data['tag'] === 'string' || data['tag'] instanceof String)) {
            throw new Error("Expected the field `tag` to be a primitive type in the JSON string but got " + data['tag']);
        }
        // ensure the json data is a string
        if (data['value'] && !(typeof data['value'] === 'string' || data['value'] instanceof String)) {
            throw new Error("Expected the field `value` to be a primitive type in the JSON string but got " + data['value']);
        }

        return true;
    }


}

CompanyDatapointResponseData.RequiredProperties = ["comment", "comment_refs", "company_id", "display_label", "generated_at", "id", "not_meaningful", "page_number", "parts", "period", "source_doc", "source_type", "tag", "updated_at", "value"];

/**
 * @member {String} comment
 */
CompanyDatapointResponseData.prototype['comment'] = undefined;

/**
 * @member {Array.<module:model/CommentRefsInner>} comment_refs
 */
CompanyDatapointResponseData.prototype['comment_refs'] = undefined;

/**
 * @member {String} company_id
 */
CompanyDatapointResponseData.prototype['company_id'] = undefined;

/**
 * @member {String} display_label
 */
CompanyDatapointResponseData.prototype['display_label'] = undefined;

/**
 * @member {Date} generated_at
 */
CompanyDatapointResponseData.prototype['generated_at'] = undefined;

/**
 * @member {String} id
 */
CompanyDatapointResponseData.prototype['id'] = undefined;

/**
 * @member {Boolean} not_meaningful
 */
CompanyDatapointResponseData.prototype['not_meaningful'] = undefined;

/**
 * @member {Number} page_number
 */
CompanyDatapointResponseData.prototype['page_number'] = undefined;

/**
 * @member {Array.<module:model/PartsInner>} parts
 */
CompanyDatapointResponseData.prototype['parts'] = undefined;

/**
 * @member {String} period
 */
CompanyDatapointResponseData.prototype['period'] = undefined;

/**
 * @member {String} source_doc
 */
CompanyDatapointResponseData.prototype['source_doc'] = undefined;

/**
 * @member {String} source_type
 */
CompanyDatapointResponseData.prototype['source_type'] = undefined;

/**
 * @member {String} tag
 */
CompanyDatapointResponseData.prototype['tag'] = undefined;

/**
 * @member {Date} updated_at
 */
CompanyDatapointResponseData.prototype['updated_at'] = undefined;

/**
 * @member {String} value
 */
CompanyDatapointResponseData.prototype['value'] = undefined;






export default CompanyDatapointResponseData;

