/**
 * Data API
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import PeriodDatesInner from './PeriodDatesInner';

/**
 * The CompanyPeriodDatesResponseData model module.
 * @module model/CompanyPeriodDatesResponseData
 * @version 1.0.0
 */
class CompanyPeriodDatesResponseData {
    /**
     * Constructs a new <code>CompanyPeriodDatesResponseData</code>.
     * @alias module:model/CompanyPeriodDatesResponseData
     * @param companyId {String} 
     * @param generatedAt {Date} 
     * @param updatedAt {Date} 
     */
    constructor(companyId, generatedAt, updatedAt) { 
        
        CompanyPeriodDatesResponseData.initialize(this, companyId, generatedAt, updatedAt);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, companyId, generatedAt, updatedAt) { 
        obj['company_id'] = companyId;
        obj['generated_at'] = generatedAt;
        obj['updated_at'] = updatedAt;
    }

    /**
     * Constructs a <code>CompanyPeriodDatesResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/CompanyPeriodDatesResponseData} obj Optional instance to populate.
     * @return {module:model/CompanyPeriodDatesResponseData} The populated <code>CompanyPeriodDatesResponseData</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new CompanyPeriodDatesResponseData();

            if (data.hasOwnProperty('company_id')) {
                obj['company_id'] = ApiClient.convertToType(data['company_id'], 'String');
            }
            if (data.hasOwnProperty('generated_at')) {
                obj['generated_at'] = ApiClient.convertToType(data['generated_at'], 'Date');
            }
            if (data.hasOwnProperty('period_dates')) {
                obj['period_dates'] = ApiClient.convertToType(data['period_dates'], [PeriodDatesInner]);
            }
            if (data.hasOwnProperty('updated_at')) {
                obj['updated_at'] = ApiClient.convertToType(data['updated_at'], 'Date');
            }
        }
        return obj;
    }

    /**
     * Validates the JSON data with respect to <code>CompanyPeriodDatesResponseData</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>CompanyPeriodDatesResponseData</code>.
     */
    static validateJSON(data) {
        // check to make sure all required properties are present in the JSON string
        for (const property of CompanyPeriodDatesResponseData.RequiredProperties) {
            if (!data[property]) {
                throw new Error("The required field `" + property + "` is not found in the JSON data: " + JSON.stringify(data));
            }
        }
        // ensure the json data is a string
        if (data['company_id'] && !(typeof data['company_id'] === 'string' || data['company_id'] instanceof String)) {
            throw new Error("Expected the field `company_id` to be a primitive type in the JSON string but got " + data['company_id']);
        }
        if (data['period_dates']) { // data not null
            // ensure the json data is an array
            if (!Array.isArray(data['period_dates'])) {
                throw new Error("Expected the field `period_dates` to be an array in the JSON data but got " + data['period_dates']);
            }
            // validate the optional field `period_dates` (array)
            for (const item of data['period_dates']) {
                PeriodDatesInner.validateJSON(item);
            };
        }

        return true;
    }


}

CompanyPeriodDatesResponseData.RequiredProperties = ["company_id", "generated_at", "updated_at"];

/**
 * @member {String} company_id
 */
CompanyPeriodDatesResponseData.prototype['company_id'] = undefined;

/**
 * @member {Date} generated_at
 */
CompanyPeriodDatesResponseData.prototype['generated_at'] = undefined;

/**
 * @member {Array.<module:model/PeriodDatesInner>} period_dates
 */
CompanyPeriodDatesResponseData.prototype['period_dates'] = undefined;

/**
 * @member {Date} updated_at
 */
CompanyPeriodDatesResponseData.prototype['updated_at'] = undefined;






export default CompanyPeriodDatesResponseData;

