/**
 * Data API
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import TimeSeriesInner from './TimeSeriesInner';

/**
 * The CompanyTimeSeriesResponseData model module.
 * @module model/CompanyTimeSeriesResponseData
 * @version 1.0.0
 */
class CompanyTimeSeriesResponseData {
    /**
     * Constructs a new <code>CompanyTimeSeriesResponseData</code>.
     * @alias module:model/CompanyTimeSeriesResponseData
     * @param companyId {String} 
     * @param generatedAt {Date} 
     * @param interval {String} 
     * @param tag {String} 
     * @param timeSeries {Array.<module:model/TimeSeriesInner>} 
     * @param updatedAt {Date} 
     */
    constructor(companyId, generatedAt, interval, tag, timeSeries, updatedAt) { 
        
        CompanyTimeSeriesResponseData.initialize(this, companyId, generatedAt, interval, tag, timeSeries, updatedAt);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, companyId, generatedAt, interval, tag, timeSeries, updatedAt) { 
        obj['company_id'] = companyId;
        obj['generated_at'] = generatedAt;
        obj['interval'] = interval;
        obj['tag'] = tag;
        obj['time_series'] = timeSeries;
        obj['updated_at'] = updatedAt;
    }

    /**
     * Constructs a <code>CompanyTimeSeriesResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/CompanyTimeSeriesResponseData} obj Optional instance to populate.
     * @return {module:model/CompanyTimeSeriesResponseData} The populated <code>CompanyTimeSeriesResponseData</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new CompanyTimeSeriesResponseData();

            if (data.hasOwnProperty('company_id')) {
                obj['company_id'] = ApiClient.convertToType(data['company_id'], 'String');
            }
            if (data.hasOwnProperty('generated_at')) {
                obj['generated_at'] = ApiClient.convertToType(data['generated_at'], 'Date');
            }
            if (data.hasOwnProperty('interval')) {
                obj['interval'] = ApiClient.convertToType(data['interval'], 'String');
            }
            if (data.hasOwnProperty('tag')) {
                obj['tag'] = ApiClient.convertToType(data['tag'], 'String');
            }
            if (data.hasOwnProperty('time_series')) {
                obj['time_series'] = ApiClient.convertToType(data['time_series'], [TimeSeriesInner]);
            }
            if (data.hasOwnProperty('updated_at')) {
                obj['updated_at'] = ApiClient.convertToType(data['updated_at'], 'Date');
            }
        }
        return obj;
    }

    /**
     * Validates the JSON data with respect to <code>CompanyTimeSeriesResponseData</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>CompanyTimeSeriesResponseData</code>.
     */
    static validateJSON(data) {
        // check to make sure all required properties are present in the JSON string
        for (const property of CompanyTimeSeriesResponseData.RequiredProperties) {
            if (!data[property]) {
                throw new Error("The required field `" + property + "` is not found in the JSON data: " + JSON.stringify(data));
            }
        }
        // ensure the json data is a string
        if (data['company_id'] && !(typeof data['company_id'] === 'string' || data['company_id'] instanceof String)) {
            throw new Error("Expected the field `company_id` to be a primitive type in the JSON string but got " + data['company_id']);
        }
        // ensure the json data is a string
        if (data['interval'] && !(typeof data['interval'] === 'string' || data['interval'] instanceof String)) {
            throw new Error("Expected the field `interval` to be a primitive type in the JSON string but got " + data['interval']);
        }
        // ensure the json data is a string
        if (data['tag'] && !(typeof data['tag'] === 'string' || data['tag'] instanceof String)) {
            throw new Error("Expected the field `tag` to be a primitive type in the JSON string but got " + data['tag']);
        }
        if (data['time_series']) { // data not null
            // ensure the json data is an array
            if (!Array.isArray(data['time_series'])) {
                throw new Error("Expected the field `time_series` to be an array in the JSON data but got " + data['time_series']);
            }
            // validate the optional field `time_series` (array)
            for (const item of data['time_series']) {
                TimeSeriesInner.validateJSON(item);
            };
        }

        return true;
    }


}

CompanyTimeSeriesResponseData.RequiredProperties = ["company_id", "generated_at", "interval", "tag", "time_series", "updated_at"];

/**
 * @member {String} company_id
 */
CompanyTimeSeriesResponseData.prototype['company_id'] = undefined;

/**
 * @member {Date} generated_at
 */
CompanyTimeSeriesResponseData.prototype['generated_at'] = undefined;

/**
 * @member {String} interval
 */
CompanyTimeSeriesResponseData.prototype['interval'] = undefined;

/**
 * @member {String} tag
 */
CompanyTimeSeriesResponseData.prototype['tag'] = undefined;

/**
 * @member {Array.<module:model/TimeSeriesInner>} time_series
 */
CompanyTimeSeriesResponseData.prototype['time_series'] = undefined;

/**
 * @member {Date} updated_at
 */
CompanyTimeSeriesResponseData.prototype['updated_at'] = undefined;






export default CompanyTimeSeriesResponseData;

