/**
 * Data API
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import Multiplier from './Multiplier';

/**
 * The DataInner model module.
 * @module model/DataInner
 * @version 1.0.0
 */
class DataInner {
    /**
     * Constructs a new <code>DataInner</code>.
     * @alias module:model/DataInner
     * @param accountingStandard {String} 
     * @param countryCode {String} 
     * @param currency {String} 
     * @param description {String} 
     * @param frequency {String} 
     * @param generatedAt {Date} 
     * @param gicsCode {String} 
     * @param id {String} 
     * @param lastReportedDate {Date} 
     * @param lastReportedDocumentType {String} 
     * @param lastReportedPeriod {String} 
     * @param multiplier {module:model/Multiplier} 
     * @param name {String} 
     * @param ownership {String} 
     * @param retired {Boolean} 
     * @param ticker {String} 
     * @param updatedAt {Date} 
     * @param yearEnd {String} 
     */
    constructor(accountingStandard, countryCode, currency, description, frequency, generatedAt, gicsCode, id, lastReportedDate, lastReportedDocumentType, lastReportedPeriod, multiplier, name, ownership, retired, ticker, updatedAt, yearEnd) { 
        
        DataInner.initialize(this, accountingStandard, countryCode, currency, description, frequency, generatedAt, gicsCode, id, lastReportedDate, lastReportedDocumentType, lastReportedPeriod, multiplier, name, ownership, retired, ticker, updatedAt, yearEnd);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, accountingStandard, countryCode, currency, description, frequency, generatedAt, gicsCode, id, lastReportedDate, lastReportedDocumentType, lastReportedPeriod, multiplier, name, ownership, retired, ticker, updatedAt, yearEnd) { 
        obj['accounting_standard'] = accountingStandard;
        obj['country_code'] = countryCode;
        obj['currency'] = currency;
        obj['description'] = description;
        obj['frequency'] = frequency;
        obj['generated_at'] = generatedAt;
        obj['gics_code'] = gicsCode;
        obj['id'] = id;
        obj['last_reported_date'] = lastReportedDate;
        obj['last_reported_document_type'] = lastReportedDocumentType;
        obj['last_reported_period'] = lastReportedPeriod;
        obj['multiplier'] = multiplier;
        obj['name'] = name;
        obj['ownership'] = ownership;
        obj['retired'] = retired;
        obj['ticker'] = ticker;
        obj['updated_at'] = updatedAt;
        obj['year_end'] = yearEnd;
    }

    /**
     * Constructs a <code>DataInner</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/DataInner} obj Optional instance to populate.
     * @return {module:model/DataInner} The populated <code>DataInner</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new DataInner();

            if (data.hasOwnProperty('accounting_standard')) {
                obj['accounting_standard'] = ApiClient.convertToType(data['accounting_standard'], 'String');
            }
            if (data.hasOwnProperty('country_code')) {
                obj['country_code'] = ApiClient.convertToType(data['country_code'], 'String');
            }
            if (data.hasOwnProperty('created_at')) {
                obj['created_at'] = ApiClient.convertToType(data['created_at'], 'Date');
            }
            if (data.hasOwnProperty('currency')) {
                obj['currency'] = ApiClient.convertToType(data['currency'], 'String');
            }
            if (data.hasOwnProperty('description')) {
                obj['description'] = ApiClient.convertToType(data['description'], 'String');
            }
            if (data.hasOwnProperty('frequency')) {
                obj['frequency'] = ApiClient.convertToType(data['frequency'], 'String');
            }
            if (data.hasOwnProperty('generated_at')) {
                obj['generated_at'] = ApiClient.convertToType(data['generated_at'], 'Date');
            }
            if (data.hasOwnProperty('gics_code')) {
                obj['gics_code'] = ApiClient.convertToType(data['gics_code'], 'String');
            }
            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'String');
            }
            if (data.hasOwnProperty('last_reported_date')) {
                obj['last_reported_date'] = ApiClient.convertToType(data['last_reported_date'], 'Date');
            }
            if (data.hasOwnProperty('last_reported_document_type')) {
                obj['last_reported_document_type'] = ApiClient.convertToType(data['last_reported_document_type'], 'String');
            }
            if (data.hasOwnProperty('last_reported_period')) {
                obj['last_reported_period'] = ApiClient.convertToType(data['last_reported_period'], 'String');
            }
            if (data.hasOwnProperty('multiplier')) {
                obj['multiplier'] = Multiplier.constructFromObject(data['multiplier']);
            }
            if (data.hasOwnProperty('name')) {
                obj['name'] = ApiClient.convertToType(data['name'], 'String');
            }
            if (data.hasOwnProperty('next_reporting_date')) {
                obj['next_reporting_date'] = ApiClient.convertToType(data['next_reporting_date'], 'String');
            }
            if (data.hasOwnProperty('next_reporting_period')) {
                obj['next_reporting_period'] = ApiClient.convertToType(data['next_reporting_period'], 'String');
            }
            if (data.hasOwnProperty('ownership')) {
                obj['ownership'] = ApiClient.convertToType(data['ownership'], 'String');
            }
            if (data.hasOwnProperty('retired')) {
                obj['retired'] = ApiClient.convertToType(data['retired'], 'Boolean');
            }
            if (data.hasOwnProperty('retired_date')) {
                obj['retired_date'] = ApiClient.convertToType(data['retired_date'], 'Date');
            }
            if (data.hasOwnProperty('ticker')) {
                obj['ticker'] = ApiClient.convertToType(data['ticker'], 'String');
            }
            if (data.hasOwnProperty('updated_at')) {
                obj['updated_at'] = ApiClient.convertToType(data['updated_at'], 'Date');
            }
            if (data.hasOwnProperty('url_investors_relations')) {
                obj['url_investors_relations'] = ApiClient.convertToType(data['url_investors_relations'], 'String');
            }
            if (data.hasOwnProperty('year_end')) {
                obj['year_end'] = ApiClient.convertToType(data['year_end'], 'String');
            }
        }
        return obj;
    }

    /**
     * Validates the JSON data with respect to <code>DataInner</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>DataInner</code>.
     */
    static validateJSON(data) {
        // check to make sure all required properties are present in the JSON string
        for (const property of DataInner.RequiredProperties) {
            if (!data[property]) {
                throw new Error("The required field `" + property + "` is not found in the JSON data: " + JSON.stringify(data));
            }
        }
        // ensure the json data is a string
        if (data['accounting_standard'] && !(typeof data['accounting_standard'] === 'string' || data['accounting_standard'] instanceof String)) {
            throw new Error("Expected the field `accounting_standard` to be a primitive type in the JSON string but got " + data['accounting_standard']);
        }
        // ensure the json data is a string
        if (data['country_code'] && !(typeof data['country_code'] === 'string' || data['country_code'] instanceof String)) {
            throw new Error("Expected the field `country_code` to be a primitive type in the JSON string but got " + data['country_code']);
        }
        // ensure the json data is a string
        if (data['currency'] && !(typeof data['currency'] === 'string' || data['currency'] instanceof String)) {
            throw new Error("Expected the field `currency` to be a primitive type in the JSON string but got " + data['currency']);
        }
        // ensure the json data is a string
        if (data['description'] && !(typeof data['description'] === 'string' || data['description'] instanceof String)) {
            throw new Error("Expected the field `description` to be a primitive type in the JSON string but got " + data['description']);
        }
        // ensure the json data is a string
        if (data['frequency'] && !(typeof data['frequency'] === 'string' || data['frequency'] instanceof String)) {
            throw new Error("Expected the field `frequency` to be a primitive type in the JSON string but got " + data['frequency']);
        }
        // ensure the json data is a string
        if (data['gics_code'] && !(typeof data['gics_code'] === 'string' || data['gics_code'] instanceof String)) {
            throw new Error("Expected the field `gics_code` to be a primitive type in the JSON string but got " + data['gics_code']);
        }
        // ensure the json data is a string
        if (data['id'] && !(typeof data['id'] === 'string' || data['id'] instanceof String)) {
            throw new Error("Expected the field `id` to be a primitive type in the JSON string but got " + data['id']);
        }
        // ensure the json data is a string
        if (data['last_reported_document_type'] && !(typeof data['last_reported_document_type'] === 'string' || data['last_reported_document_type'] instanceof String)) {
            throw new Error("Expected the field `last_reported_document_type` to be a primitive type in the JSON string but got " + data['last_reported_document_type']);
        }
        // ensure the json data is a string
        if (data['last_reported_period'] && !(typeof data['last_reported_period'] === 'string' || data['last_reported_period'] instanceof String)) {
            throw new Error("Expected the field `last_reported_period` to be a primitive type in the JSON string but got " + data['last_reported_period']);
        }
        // validate the optional field `multiplier`
        if (data['multiplier']) { // data not null
          Multiplier.validateJSON(data['multiplier']);
        }
        // ensure the json data is a string
        if (data['name'] && !(typeof data['name'] === 'string' || data['name'] instanceof String)) {
            throw new Error("Expected the field `name` to be a primitive type in the JSON string but got " + data['name']);
        }
        // ensure the json data is a string
        if (data['next_reporting_date'] && !(typeof data['next_reporting_date'] === 'string' || data['next_reporting_date'] instanceof String)) {
            throw new Error("Expected the field `next_reporting_date` to be a primitive type in the JSON string but got " + data['next_reporting_date']);
        }
        // ensure the json data is a string
        if (data['next_reporting_period'] && !(typeof data['next_reporting_period'] === 'string' || data['next_reporting_period'] instanceof String)) {
            throw new Error("Expected the field `next_reporting_period` to be a primitive type in the JSON string but got " + data['next_reporting_period']);
        }
        // ensure the json data is a string
        if (data['ownership'] && !(typeof data['ownership'] === 'string' || data['ownership'] instanceof String)) {
            throw new Error("Expected the field `ownership` to be a primitive type in the JSON string but got " + data['ownership']);
        }
        // ensure the json data is a string
        if (data['ticker'] && !(typeof data['ticker'] === 'string' || data['ticker'] instanceof String)) {
            throw new Error("Expected the field `ticker` to be a primitive type in the JSON string but got " + data['ticker']);
        }
        // ensure the json data is a string
        if (data['url_investors_relations'] && !(typeof data['url_investors_relations'] === 'string' || data['url_investors_relations'] instanceof String)) {
            throw new Error("Expected the field `url_investors_relations` to be a primitive type in the JSON string but got " + data['url_investors_relations']);
        }
        // ensure the json data is a string
        if (data['year_end'] && !(typeof data['year_end'] === 'string' || data['year_end'] instanceof String)) {
            throw new Error("Expected the field `year_end` to be a primitive type in the JSON string but got " + data['year_end']);
        }

        return true;
    }


}

DataInner.RequiredProperties = ["accounting_standard", "country_code", "currency", "description", "frequency", "generated_at", "gics_code", "id", "last_reported_date", "last_reported_document_type", "last_reported_period", "multiplier", "name", "ownership", "retired", "ticker", "updated_at", "year_end"];

/**
 * @member {String} accounting_standard
 */
DataInner.prototype['accounting_standard'] = undefined;

/**
 * @member {String} country_code
 */
DataInner.prototype['country_code'] = undefined;

/**
 * @member {Date} created_at
 */
DataInner.prototype['created_at'] = undefined;

/**
 * @member {String} currency
 */
DataInner.prototype['currency'] = undefined;

/**
 * @member {String} description
 */
DataInner.prototype['description'] = undefined;

/**
 * @member {String} frequency
 */
DataInner.prototype['frequency'] = undefined;

/**
 * @member {Date} generated_at
 */
DataInner.prototype['generated_at'] = undefined;

/**
 * @member {String} gics_code
 */
DataInner.prototype['gics_code'] = undefined;

/**
 * @member {String} id
 */
DataInner.prototype['id'] = undefined;

/**
 * @member {Date} last_reported_date
 */
DataInner.prototype['last_reported_date'] = undefined;

/**
 * @member {String} last_reported_document_type
 */
DataInner.prototype['last_reported_document_type'] = undefined;

/**
 * @member {String} last_reported_period
 */
DataInner.prototype['last_reported_period'] = undefined;

/**
 * @member {module:model/Multiplier} multiplier
 */
DataInner.prototype['multiplier'] = undefined;

/**
 * @member {String} name
 */
DataInner.prototype['name'] = undefined;

/**
 * @member {String} next_reporting_date
 */
DataInner.prototype['next_reporting_date'] = undefined;

/**
 * @member {String} next_reporting_period
 */
DataInner.prototype['next_reporting_period'] = undefined;

/**
 * @member {String} ownership
 */
DataInner.prototype['ownership'] = undefined;

/**
 * @member {Boolean} retired
 */
DataInner.prototype['retired'] = undefined;

/**
 * @member {Date} retired_date
 */
DataInner.prototype['retired_date'] = undefined;

/**
 * @member {String} ticker
 */
DataInner.prototype['ticker'] = undefined;

/**
 * @member {Date} updated_at
 */
DataInner.prototype['updated_at'] = undefined;

/**
 * @member {String} url_investors_relations
 */
DataInner.prototype['url_investors_relations'] = undefined;

/**
 * @member {String} year_end
 */
DataInner.prototype['year_end'] = undefined;






export default DataInner;

