/**
 * Data API
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import ComparablesInner from './ComparablesInner';

/**
 * The DataInner1 model module.
 * @module model/DataInner1
 * @version 1.0.0
 */
class DataInner1 {
    /**
     * Constructs a new <code>DataInner1</code>.
     * @alias module:model/DataInner1
     * @param companyId {String} 
     * @param generatedAt {Date} 
     * @param interval {String} 
     * @param reportPeriod {String} 
     * @param updatedAt {Date} 
     */
    constructor(companyId, generatedAt, interval, reportPeriod, updatedAt) { 
        
        DataInner1.initialize(this, companyId, generatedAt, interval, reportPeriod, updatedAt);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, companyId, generatedAt, interval, reportPeriod, updatedAt) { 
        obj['company_id'] = companyId;
        obj['generated_at'] = generatedAt;
        obj['interval'] = interval;
        obj['report_period'] = reportPeriod;
        obj['updated_at'] = updatedAt;
    }

    /**
     * Constructs a <code>DataInner1</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/DataInner1} obj Optional instance to populate.
     * @return {module:model/DataInner1} The populated <code>DataInner1</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new DataInner1();

            if (data.hasOwnProperty('company_id')) {
                obj['company_id'] = ApiClient.convertToType(data['company_id'], 'String');
            }
            if (data.hasOwnProperty('comparables')) {
                obj['comparables'] = ApiClient.convertToType(data['comparables'], [ComparablesInner]);
            }
            if (data.hasOwnProperty('generated_at')) {
                obj['generated_at'] = ApiClient.convertToType(data['generated_at'], 'Date');
            }
            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'Number');
            }
            if (data.hasOwnProperty('interval')) {
                obj['interval'] = ApiClient.convertToType(data['interval'], 'String');
            }
            if (data.hasOwnProperty('report_period')) {
                obj['report_period'] = ApiClient.convertToType(data['report_period'], 'String');
            }
            if (data.hasOwnProperty('updated_at')) {
                obj['updated_at'] = ApiClient.convertToType(data['updated_at'], 'Date');
            }
        }
        return obj;
    }

    /**
     * Validates the JSON data with respect to <code>DataInner1</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>DataInner1</code>.
     */
    static validateJSON(data) {
        // check to make sure all required properties are present in the JSON string
        for (const property of DataInner1.RequiredProperties) {
            if (!data[property]) {
                throw new Error("The required field `" + property + "` is not found in the JSON data: " + JSON.stringify(data));
            }
        }
        // ensure the json data is a string
        if (data['company_id'] && !(typeof data['company_id'] === 'string' || data['company_id'] instanceof String)) {
            throw new Error("Expected the field `company_id` to be a primitive type in the JSON string but got " + data['company_id']);
        }
        if (data['comparables']) { // data not null
            // ensure the json data is an array
            if (!Array.isArray(data['comparables'])) {
                throw new Error("Expected the field `comparables` to be an array in the JSON data but got " + data['comparables']);
            }
            // validate the optional field `comparables` (array)
            for (const item of data['comparables']) {
                ComparablesInner.validateJSON(item);
            };
        }
        // ensure the json data is a string
        if (data['interval'] && !(typeof data['interval'] === 'string' || data['interval'] instanceof String)) {
            throw new Error("Expected the field `interval` to be a primitive type in the JSON string but got " + data['interval']);
        }
        // ensure the json data is a string
        if (data['report_period'] && !(typeof data['report_period'] === 'string' || data['report_period'] instanceof String)) {
            throw new Error("Expected the field `report_period` to be a primitive type in the JSON string but got " + data['report_period']);
        }

        return true;
    }


}

DataInner1.RequiredProperties = ["company_id", "generated_at", "interval", "report_period", "updated_at"];

/**
 * @member {String} company_id
 */
DataInner1.prototype['company_id'] = undefined;

/**
 * @member {Array.<module:model/ComparablesInner>} comparables
 */
DataInner1.prototype['comparables'] = undefined;

/**
 * @member {Date} generated_at
 */
DataInner1.prototype['generated_at'] = undefined;

/**
 * @member {Number} id
 */
DataInner1.prototype['id'] = undefined;

/**
 * @member {String} interval
 */
DataInner1.prototype['interval'] = undefined;

/**
 * @member {String} report_period
 */
DataInner1.prototype['report_period'] = undefined;

/**
 * @member {Date} updated_at
 */
DataInner1.prototype['updated_at'] = undefined;






export default DataInner1;

