/**
 * Data API
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The Multiplier model module.
 * @module model/Multiplier
 * @version 1.0.0
 */
class Multiplier {
    /**
     * Constructs a new <code>Multiplier</code>.
     * @alias module:model/Multiplier
     * @param {(module:model/Null|module:model/String)} instance The actual instance to initialize Multiplier.
     */
    constructor(instance = null) {
        if (instance === null) {
            this.actualInstance = null;
            return;
        }
        var match = 0;
        var errorMessages = [];
        try {
            // validate string
            if (!(typeof instance === 'string')) {
                throw new Error("Invalid value. Must be string. Input: " + JSON.stringify(instance));
            }
            this.actualInstance = instance;
            match++;
        } catch(err) {
            // json data failed to deserialize into String
            errorMessages.push("Failed to construct String: " + err)
        }

        try {
            if (typeof instance === "Null") {
                this.actualInstance = instance;
            } else {
                // plain JS object
                // validate the object
                Null.validateJSON(instance); // throw an exception if no match
                // create Null from JS object
                this.actualInstance = Null.constructFromObject(instance);
            }
            match++;
        } catch(err) {
            // json data failed to deserialize into Null
            errorMessages.push("Failed to construct Null: " + err)
        }

        if (match > 1) {
            throw new Error("Multiple matches found constructing `Multiplier` with oneOf schemas Null, String. Input: " + JSON.stringify(instance));
        } else if (match === 0) {
            this.actualInstance = null; // clear the actual instance in case there are multiple matches
            throw new Error("No match found constructing `Multiplier` with oneOf schemas Null, String. Details: " +
                            errorMessages.join(", "));
        } else { // only 1 match
            // the input is valid
        }
    }

    /**
     * Constructs a <code>Multiplier</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Multiplier} obj Optional instance to populate.
     * @return {module:model/Multiplier} The populated <code>Multiplier</code> instance.
     */
    static constructFromObject(data, obj) {
        return new Multiplier(data);
    }

    /**
     * Gets the actual instance, which can be <code>Null</code>, <code>String</code>.
     * @return {(module:model/Null|module:model/String)} The actual instance.
     */
    getActualInstance() {
        return this.actualInstance;
    }

    /**
     * Sets the actual instance, which can be <code>Null</code>, <code>String</code>.
     * @param {(module:model/Null|module:model/String)} obj The actual instance.
     */
    setActualInstance(obj) {
       this.actualInstance = Multiplier.constructFromObject(obj).getActualInstance();
    }

    /**
     * Returns the JSON representation of the actual instance.
     * @return {string}
     */
    toJSON = function(){
        return this.getActualInstance();
    }

    /**
     * Create an instance of Multiplier from a JSON string.
     * @param {string} json_string JSON string.
     * @return {module:model/Multiplier} An instance of Multiplier.
     */
    static fromJSON = function(json_string){
        return Multiplier.constructFromObject(JSON.parse(json_string));
    }
}


Multiplier.OneOf = ["Null", "String"];

export default Multiplier;

